﻿// AriDEV develop this Plugin with passion!
// This Plugin catch Beasts for your Barn!
// https://github.com/AriDEV
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Frames;
using Styx.CommonBot.Inventory;
using Styx.CommonBot.Profiles;
using Styx.Helpers;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.Misc;
using Styx.WoWInternals.World;
using Styx.WoWInternals.WoWObjects;

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Windows.Media;
using System.Xml.Linq;
using System.Collections;

namespace AutoBarnTraper
{
    
    public class AutoBarnTraper : HBPlugin
    {
        #region Globals
        public override string Name { get { return "AutoBarnTraper"; } }
        public override string Author { get { return "AriDEV"; } }
        public override Version Version { get { return new Version(1, 0, 0, 8); } }
        public override string ButtonText { get { return "View Config"; } }
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        Hashtable trap = new Hashtable();
        bool init = false;
        int sleepTime = 20000;
        #endregion

        public override void OnButtonPress()
        {

            AutoBarnTraperGui g = new AutoBarnTraperGui();
            g.trap = this.trap;
            g.ShowDialog();
        }

        public static WoWItem FindFirstUsableItemBySpell(params string[] spellNames)
        {
            List<WoWItem> carried = StyxWoW.Me.CarriedItems;
            // Yes, this is a bit of a hack. But the cost of creating an object each call, is negated by the speed of the Contains from a hash set.
            // So take your optimization bitching elsewhere.
            var spellNameHashes = new HashSet<string>(spellNames);

            return (from i in carried
                    let spells = i.Effects
                    where i.ItemInfo != null && spells != null && spells.Count != 0 &&
                          i.Usable &&
                          i.Cooldown == 0 &&
                          i.ItemInfo.RequiredLevel <= StyxWoW.Me.Level &&
                          spells.Any(s => s.Spell != null && spellNameHashes.Contains(s.Spell.Name))
                    orderby i.ItemInfo.Level descending
                    select i).FirstOrDefault();
        }

        public WoWItem UsableTrapItem()
        {
            return FindFirstUsableItemBySpell("Deadly Iron Trap", "Improved Iron Trap", "Iron Trap"); // Reversed order to use strongest trap if u have 2 difrent traps.
        }

        bool checkEntry(uint entry)
        {
            if (trap.ContainsKey(entry)) { return true; }
            else { return false; }
        }

        void addBeastTrap(uint entry, string info) {
            trap.Add(entry, info);
        }

        public override void Pulse()
        {

            if (!init) {
                base.OnEnable();
                Logging.Write(LogLevel.Normal, Colors.DarkRed, "Autobarntrap: Doing init");
                // Frostfire Ridge
                addBeastTrap(72162, "Wooly Clefthoof;Frostfire Ridge");
                addBeastTrap(76593, "Frost Wolf Alpha;Frostfire Ridge");
                addBeastTrap(76597, "Frost Wolf;Frostfire Ridge");
                addBeastTrap(75416, "Coldsnout Boar;Frostfire Ridge");
                addBeastTrap(79756, "Coldsnout Sow;Frostfire Ridge");
                // Nagrand
                addBeastTrap(78575, "Leatherhide Clefthoof;Nagrand");
                addBeastTrap(81898, "Leatherhide Bull;Nagrand");
                addBeastTrap(78459, "Tenderhoof Meadowstomper;Nagrand");
                addBeastTrap(78460, "Meadowstomper;Nagrand");
                addBeastTrap(78277, "Breezestrider Colt;Nagrand");
                addBeastTrap(78278, "Breezestrider Talbuk;Nagrand");
                // Shadowmoon Valley
                addBeastTrap(74169, "Gloomshade Howler;Shadowmoon Valley");
                addBeastTrap(78385, "Pearltusk Grazer;Shadowmoon Valley");
                addBeastTrap(82452, "Ancient Pearltusk;Shadowmoon Valley");
                addBeastTrap(78276, "Silverpelt Charger;Shadowmoon Valley");
                addBeastTrap(78275, "Silverpelt Doe;Shadowmoon Valley");
                addBeastTrap(87698, "Rockhide Bull;Shadowmoon Valley");
                addBeastTrap(87700, "Rockhide Grazer;Shadowmoon Valley");
                addBeastTrap(82308, "Shadowmoon Stalker;Shadowmoon Valley");  
                //<Vendor Name="Ancient Pearltusk" Entry="82452" Type="Repair" X="1437.82" Y="25.48667" Z="60.95071" />
                init = true;
            }
        
        

            if (!Me.Combat || !Me.IsAlive || Me.IsGhost || Me.IsOnTransport || Me.OnTaxi || Me.Stunned || (Me.Mounted && Me.IsFlying)) // Chillax
            {
                return;
            }
            Logging.Write(LogLevel.Normal, Colors.DarkRed, "check if trap time");
            if (Me.Combat && Me.CurrentTarget.HealthPercent <= 60) // Pay Attn!
            {
                Logging.Write(LogLevel.Normal, Colors.DarkRed, "Do trapping :)");
                ObjectManager.Update();
                //Styx.Common.Logging.Write(System.Windows.Media.Color.FromRgb(255,0,255), "Update ObjectManager!");
                List<WoWUnit> objList = ObjectManager.GetObjectsOfType<WoWUnit>().Where(o => checkEntry( o.Entry ) ).OrderBy(o => o.Distance).ToList();

                Styx.Common.Logging.Write(System.Windows.Media.Color.FromRgb(255, 0, 255), "AutoBarnTraper: Lists " + objList.Count().ToString() + " items: " + objList.ToString());

                foreach (WoWUnit o in objList)
                {
                    if (o.IsWithinMeleeRange)
                    {
                        if (!o.IsDead && !o.IsPet)
                        {
                            WoWItem TrapItem = UsableTrapItem();
                            if (TrapItem != null && TrapItem.Cooldown == 0)
                            {
                                TrapItem.UseContainerItem();
                                Styx.Common.Logging.Write(System.Windows.Media.Color.FromRgb(255,0,255), "AutoBarnTraper: " + TrapItem.Name + "thrown at" + o.Name + "! ");    
                                Me.SetFacing(90);
                                System.Threading.Thread.Sleep(300);
                                if (!Me.IsFacing(Me.CurrentTarget.Location))
                                {
                                    System.Threading.Thread.Sleep(sleepTime);
                                }
                                else
                                {
                                    Me.SetFacing(180);
                                    System.Threading.Thread.Sleep(300);
                                    if (!Me.IsFacing(Me.CurrentTarget.Location))
                                    {
                                        System.Threading.Thread.Sleep(sleepTime);
                                    }
                                    else {
                                        Me.SetFacing(270);
                                        System.Threading.Thread.Sleep(sleepTime);
                                    }

                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
    